import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsDictionary {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  CategoryId!: bigint;
  Code?: string;
  Name?: string;
  Value?: string;
  Description?: string;
  Enabled!: unknown;
  Sort!: number;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsDictionarySchema = defineEntity({
  class: ScsDictionary,
  comment: '数据字典',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    CategoryId: p.bigint().name('CategoryId').comment('分类id'),
    Code: p.string().name('Code').length(20).nullable().comment('编码'),
    Name: p.string().name('Name').length(20).nullable().comment('名称'),
    Value: p.string().name('Value').nullable().comment('值'),
    Description: p.string().name('Description').length(100).nullable().comment('说明'),
    Enabled: p.array().name('Enabled').comment('启用'),
    Sort: p.integer().name('Sort').comment('排序'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
